package com.abcinc.phonelist;

/**
 * JavaBean holding one contact.
 *
 * @author Wellie W. Chao
 */
public class ContactBean {

	// ------------------------------------------------------- Static Variables

	// ----------------------------------------------------- Instance Variables

	// unique ID value used as a reference to the contact entry
	private Integer id = null;

	private String lastName = null;
	private String firstName = null;
	private String phone = null;
	private String fax = null;
	private String email = null;

	// ----------------------------------------------------------- Constructors

	public ContactBean() {
	}

	// -------------------------------------------------------- Private Methods

	// ------------------------------------------------------ Protected Methods

	// ----------------------------------------------------- Accessors/Mutators

	public Integer getId() {
		return id;
	}

	public void setId(Integer id) {
		this.id = id;
	}

	public String getLastName() {
		return lastName;
	}

	public void setLastName(String lastName) {
		this.lastName = lastName;
	}

	public String getFirstName() {
		return firstName;
	}

	public void setFirstName(String firstName) {
		this.firstName = firstName;
	}

	public String getPhone() {
		return phone;
	}

	public void setPhone(String phone) {
		this.phone = phone;
	}

	public String getFax() {
		return fax;
	}

	public void setFax(String fax) {
		this.fax = fax;
	}

	public String getEmail() {
		return email;
	}

	public void setEmail(String email) {
		this.email = email;
	}

	// --------------------------------------------------------- Public Methods

	// determine whether this ContactBean instance has the same field
	// values as another object. Technically we should override
	// hashCode() from the Object class as well, but it is not entirely
	// necessary for the purposes of this example.
	public boolean equals(Object object) {
		boolean returnValue = false;
		if ((object != null) && (object instanceof ContactBean)) {
			ContactBean contactBean = (ContactBean)object;
			if ((getLastName() != null) && (getLastName().equals(contactBean.getLastName())) &&
					(getFirstName() != null) && (getFirstName().equals(contactBean.getFirstName())) &&
					(getPhone() != null) && (getPhone().equals(contactBean.getPhone())) &&
					(getFax() != null) && (getFax().equals(contactBean.getFax())) &&
					(getEmail() != null) && (getEmail().equals(contactBean.getEmail()))) {
				returnValue = true;
			}
		}
		return returnValue;
	}

	// -------------------------------------------------- Public Static Methods

}
