package com.abcinc.phonelist;

import java.util.ArrayList;
import java.util.List;

/**
 * In-memory database of contact entries.
 *
 * @author Wellie W. Chao
 */
public class ContactDatabase {

	// ------------------------------------------------------- Static Variables

	// List object storing all of the contact entries in memory.
	private static List beanList = new ArrayList();

	// ----------------------------------------------------- Instance Variables

	// ----------------------------------------------------------- Constructors

	// -------------------------------------------------------- Private Methods

	// ------------------------------------------------------ Protected Methods

	// ----------------------------------------------------- Accessors/Mutators

	// --------------------------------------------------------- Public Methods
	
	// -------------------------------------------------- Public Static Methods

	/**
	 * Return the list of ContactBean instances in the in-memory
	 * database.
	 *
	 * @return a List object containing ContactBean instances.
	 */
	public static List getList() {
		return beanList;
	}

	/**
	 * Get a ContactBean instance by its ID value.
	 *
	 * @param id the ID value of the ContactBean.
	 * @return the ContactBean instance with the specified ID value, or
	 * null if no ContactBean in the database has the specified ID
	 * value.
	 */
	public static ContactBean getBeanById(Integer id) {
		for(int i = 0; i < beanList.size(); i++) {
			ContactBean contactBean = (ContactBean)beanList.get(i);
			if (contactBean.getId().equals(id)) {
				return contactBean;
			}
		}
		return null;
	}

	/**
	 * Add a new ContactBean to the database.
	 *
	 * @param contactBean the new ContactBean instance to add.
	 */
	public static void addBean(ContactBean contactBean) {
		beanList.add(contactBean);
	}

	/**
	 * Delete the ContactBean instance with the specified ID value.
	 *
	 * @param id the ID value of the ContactBean you wish to delete.
	 */
	public static void deleteBeanWithId(Integer id) {
		int i = 0;
		while(i < beanList.size()) {
			ContactBean contactBean = (ContactBean)beanList.get(i);
			if (contactBean.getId().equals(id)) {
				beanList.remove(i);
				break;
			} else {
				i++;
			}
		}
	}
	
}
