package com.abcinc.phonelist;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

/**
 * Implementation of <strong>Action</strong> that populates a form
 * with fields values from an existing contact and then forwards to
 * the view.
 *
 * @author Wellie W. Chao
 */
public class EditAction extends Action {

	// ------------------------------------------------------- Static Variables

	// ----------------------------------------------------- Instance Variables

	// ----------------------------------------------------------- Constructors

	// -------------------------------------------------------- Private Methods

	// ------------------------------------------------- Private Static Methods

	// ----------------------------------------------------- Accessors/Mutators

	// --------------------------------------------------------- Public Methods

	/**
	 * Process the specified HTTP request, and create the corresponding HTTP
	 * response (or forward to another web component that will create it).
	 * Return an <code>ActionForward</code> instance describing where and how
	 * control should be forwarded, or <code>null</code> if the response has
	 * already been completed.
	 *
	 * @param mapping The ActionMapping used to select this instance
	 * @param form The optional ActionForm bean for this request (if any)
	 * @param request The HTTP request we are processing
	 * @param response The HTTP response we are creating
	 *
	 * @exception Exception if the application business logic throws an
	 * exception
	 */
	public ActionForward execute
		(ActionMapping mapping,
		 ActionForm form,
		 HttpServletRequest request,
		 HttpServletResponse response)
		throws Exception {

		// Create the edit contact form
		if (form == null) {
			form = new EditForm();
			// save the form bean to a request or session attribute based on scope
			if ("request".equals(mapping.getScope())) {
				request.setAttribute(mapping.getAttribute(), form);
			} else {
				HttpSession session = request.getSession();
				session.setAttribute(mapping.getAttribute(), form);
			}
		}

		EditForm editForm = (EditForm)form;
		// get the ID value from the request parameters.
		Integer id = editForm.getId();
		// get the ContactBean from the database.
		ContactBean contactBean = ContactDatabase.getBeanById(id);
		// set the values of the form from the ContactBean instance
		// specified by the ID value obtained from the request parameters.
		editForm.setLastName(contactBean.getLastName());
		editForm.setFirstName(contactBean.getFirstName());
		editForm.setPhone(contactBean.getPhone());
		editForm.setFax(contactBean.getFax());
		editForm.setEmail(contactBean.getEmail());

		// Forward control to the edit contact page
		return mapping.getInputForward();

	}

	// -------------------------------------------------- Public Static Methods

}
