package com.abcinc.phonelist;

import javax.servlet.http.HttpServletRequest;

import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.validator.ValidatorForm;

/**
 * Form bean for the edit contact page. This form has the
 * following fields, with default values in square brackets:
 * <ul>
 * <li><b>id</b> - The id value of the contact being edited. Is null
 * for new contacts.
 * <li><b>lastName</b> - The last name of the contact. [REQUIRED]
 * <li><b>firstName</b> - The first name of the contact. [REQUIRED]
 * <li><b>phone</b> - The phone number of the contact.
 * <li><b>fax</b> - The fax number of the contact.
 * <li><b>email</b> - The email of the contact.
 * </ul>
 *
 * @author Wellie W. Chao
 */
public class EditForm extends ValidatorForm {


	// ----------------------------------------------------- Instance Variables

	/**
	 * Data fields
	 */

	private Integer id = null;
	private String lastName = null;
	private String firstName = null;
	private String phone = null;
	private String fax = null;
	private String email = null;
	
	// ------------------------------------------------------------- Properties

	/**
	 * Data fields
	 */

	public Integer getId() {
		return this.id;
	}

	public void setId(Integer id) {
		this.id = id;
	}

	public String getLastName() {
		return this.lastName;
	}

	public void setLastName(String lastName) {
		this.lastName = lastName;
	}

	public String getFirstName() {
		return this.firstName;
	}

	public void setFirstName(String firstName) {
		this.firstName = firstName;
	}

	public String getPhone() {
		return this.phone;
	}

	public void setPhone(String phone) {
		this.phone = phone;
	}

	public String getFax() {
		return this.fax;
	}

	public void setFax(String fax) {
		this.fax = fax;
	}

	public String getEmail() {
		return this.email;
	}

	public void setEmail(String email) {
		this.email = email;
	}

	// -------------------------------------------------------- Private Methods

	// ------------------------------------------------------ Protected Methods

	// --------------------------------------------------------- Public Methods

	/**
	 * Reset all properties to their default values (page by page).
	 *
	 * @param mapping The mapping used to select this instance
	 * @param request The servlet request we are processing
	 */
	public void reset(ActionMapping mapping, HttpServletRequest request) {
		if (getPage() == 0) {
			id = null;
			lastName = null;
			firstName = null;
			phone = null;
			fax = null;
			email = null;
		}
	}

	/**
	 * Validate the properties that have been set from this HTTP request,
	 * and return an <code>ActionErrors</code> object that encapsulates any
	 * validation errors that have been found.	If no errors are found, return
	 * <code>null</code> or an <code>ActionErrors</code> object with no
	 * recorded error messages.
	 *
	 * @param mapping The mapping used to select this instance
	 * @param request The servlet request we are processing
	 */
	public ActionErrors validate(ActionMapping mapping,
															 HttpServletRequest request) {

		// Perform validator framework validations
		ActionErrors errors = super.validate(mapping, request);

		if (errors == null) errors = new ActionErrors();

		/**
		 * If the validator framework found errors, display those first so
		 * we avoid a call to the database.
		 */
		if (errors.size() > 0)
			return errors;

		/**
		 * Custom validations below.
		 */

		return errors;

	}

}
